## xylib 1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(xylib C CXX)

option(USE_ZLIB "Handle compressed GZ files - requires Zlib library" ON)
option(DOWNLOAD_ZLIB "Download and build the Zlib library" OFF)
option(USE_BZIP2 "Handle compressed BZ2 files - requires Bzip2 library" OFF)
option(GUI "Build xyConvert GUI - requires wxWidgets 3.0+" ON)
option(BUILD_SHARED_LIBS "Build as a shared library" ON)

if(NOT DEFINED LIB_INSTALL_DIR)
  set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

if (POLICY CMP0042)
  cmake_policy(SET CMP0042 OLD)
endif()

# if we build static library we likely prefer 3rd-party libraries also static
if(NOT BUILD_SHARED_LIBS)
  set(CMAKE_FIND_LIBRARY_SUFFIXES
      ${CMAKE_STATIC_LIBRARY_SUFFIX} ${CMAKE_FIND_LIBRARY_SUFFIXES})
endif()
include_directories(${CMAKE_SOURCE_DIR})

find_package(Boost REQUIRED)
message(STATUS "Boost headers in: ${Boost_INCLUDE_DIR}")
include_directories(${Boost_INCLUDE_DIR})
if (BUILD_SHARED_LIBS AND WIN32)
  add_definitions(-DXYLIB_DLL=1)
endif()

if (DOWNLOAD_ZLIB)
  include(ExternalProject)
  set(zlib_install "${CMAKE_INSTALL_PREFIX}")
  ExternalProject_Add(zlib
    URL "http://zlib.net/zlib-1.2.8.tar.gz"
    URL_MD5 44d667c142d7cda120332623eab69f40
    PREFIX zlib
    CMAKE_ARGS -DCMAKE_C_FLAGS:STRING=${CMAKE_C_FLAGS}
               -DCMAKE_INSTALL_PREFIX:PATH=${zlib_install}
               -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
               -DSKIP_INSTALL_FILES=ON)

# the zlib library should be named zlib1.lib not zlib.lib
#    ExternalProject_Add_Step(zlib RenameLib
#    COMMAND ${CMAKE_COMMAND} -E copy "${zlib_install}/lib/zlib.lib"
#    "${zlib_install}/lib/zlib1.lib"
#    DEPENDEES install)
  set(ZLIB_INCLUDE_DIR "${zlib_install}/include")
  if (BUILD_SHARED_LIBS)
    if (WIN32)
      set(ZLIB_SUFFIX ${CMAKE_IMPORT_LIBRARY_SUFFIX})
    else()
      set(ZLIB_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
    endif()
  else()
    set(ZLIB_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
  endif()
  if (NOT WIN32)
    set(ZLIB_NAME libz)
  elseif (BUILD_SHARED_LIBS)
    set(ZLIB_NAME zlib)
  else() # static windows
    set(ZLIB_NAME zlibstatic)
  endif()
  set(ZLIB_LIBRARIES "${zlib_install}/lib/${ZLIB_NAME}${ZLIB_SUFFIX}")
  include_directories(${ZLIB_INCLUDE_DIR})
  message(STATUS "Using local zlib: ${ZLIB_LIBRARIES}")

elseif (USE_ZLIB)
  find_package(ZLIB REQUIRED)
  include_directories(${ZLIB_INCLUDE_DIR})
endif()

if (DEFINED ZLIB_LIBRARIES)
  add_definitions(-DHAVE_LIBZ=1)
endif()

if (USE_BZIP2)
  find_package(BZip2 REQUIRED)
  add_definitions(-DHAVE_LIBBZ2=1)
  include_directories(${Bzip2_INCLUDE_DIR})
endif()

if (GUI)
  set(wxWidgets_wxrc_EXECUTABLE no_thanks)
  find_package(wxWidgets REQUIRED adv core base)
  include(${wxWidgets_USE_FILE})
endif()

if (MSVC)
    # warning C4275: non dll-interface class 'std::runtime_error' used as base
    # for dll-interface class ...
    add_definitions( /wd4275 )
endif()

# show warnings by default
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wextra HAS_WEXTRA_FLAG)
if (HAS_WEXTRA_FLAG)
  set(EXTRA_CXX_FLAGS "-Wall -Wextra" CACHE STRING "")
endif()
set(EXTRA_CXX_FLAGS ${EXTRA_CXX_FLAGS} CACHE STRING "Flags for compiler" FORCE)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS}")


add_library(xy
            xylib/bruker_raw.cpp
            xylib/bruker_spc.cpp
            xylib/cache.cpp
            xylib/canberra_cnf.cpp
            xylib/canberra_mca.cpp
            xylib/chiplot.cpp
            xylib/cpi.cpp
            xylib/csv.cpp
            xylib/dbws.cpp
            xylib/pdcif.cpp
            xylib/philips_raw.cpp
            xylib/philips_udf.cpp
            xylib/riet7.cpp
            xylib/rigaku_dat.cpp
            xylib/specsxy.cpp
            xylib/spectra.cpp
            xylib/text.cpp
            xylib/util.cpp
            xylib/uxd.cpp
            xylib/vamas.cpp
            xylib/winspec_spe.cpp
            xylib/xfit_xdd.cpp
            xylib/xrdml.cpp
	    xylib/xsyg.cpp
            xylib/xylib.cpp)

if (DOWNLOAD_ZLIB)
  add_dependencies(xy zlib)
endif()
target_link_libraries(xy ${ZLIB_LIBRARIES} ${BZIP2_LIBRARIES})
set_target_properties(xy PROPERTIES SOVERSION 4 VERSION 4.1.1)

add_executable(xyconv xyconv.cpp)
target_link_libraries(xyconv xy ${ZLIB_LIBRARIES} ${BZIP2_LIBRARIES})

if (GUI)
  if (WIN32)
    set(RCFILE gui/xyconvert.rc)
  endif()
  add_executable(xyconvert WIN32
                 gui/xyconvert.cpp
                 gui/xybrowser.cpp
                 gui/uplot.cpp
                 ${RCFILE})
  set_property(TARGET xyconvert
               APPEND PROPERTY COMPILE_DEFINITIONS "XYCONVERT")
  target_link_libraries(xyconvert xy ${wxWidgets_LIBRARIES}
                        ${ZLIB_LIBRARIES} ${BZIP2_LIBRARIES})
  install(TARGETS xyconvert DESTINATION bin)
endif()

install(TARGETS xyconv DESTINATION bin)
install(TARGETS xy
        RUNTIME DESTINATION bin
        ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
        LIBRARY DESTINATION "${LIB_INSTALL_DIR}")
install(FILES xylib/xylib.h xylib/cache.h DESTINATION include/xylib)

## xylib 0.6

=== debian/changelog ===
xylib (0.6-1) unstable; urgency=low

  * New upstream release
  * Update URL in watch file
  * Switch to dpkg-source 3.0 (quilt) format

 -- Marcin Wojdyr <wojdyr@gmail.com>  Sun, 09 May 2010 01:20:34 +0200

xylib (0.5-1) unstable; urgency=low

  * Initial release (Closes: #563841)

 -- Marcin Wojdyr <wojdyr@gmail.com>  Sat, 27 Mar 2010 11:56:00 +0100

=== debian/control ===
Source: xylib
Priority: optional
Maintainer: Marcin Wojdyr <wojdyr@gmail.com>
Build-Depends: debhelper (>= 7), zlib1g-dev, libbz2-dev, libboost-dev
Standards-Version: 3.8.4
Section: science
Homepage: http://xylib.sourceforge.net/

Package: libxy3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: fityk (<< 0.9.2)
Suggests: fityk (>= 0.9.2)
Description: Library for reading x-y data from several file formats
 C++ library for reading files that contain x-y data from powder diffraction, 
 spectroscopy and other experimental methods. The supported formats include:
 VAMAS, pdCIF, Bruker UXD and RAW, Philips UDF and RD, Rigaku DAT, 
 Sietronics CPI, DBWS/DMPLOT, Koalariet XDD and others.

Package: libxy-dev
Section: libdevel
Architecture: any
Depends: libxy3 (= ${binary:Version}), ${misc:Depends}
Description: xylib development files
 Development files for xylib.
 .
 xylib is a C++ library for reading files that contain x-y data from powder
 diffraction, spectroscopy and other experimental methods.

Package: libxy-bin
Architecture: any
Depends: libxy3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: xylib - utilities
 xylib is a C++ library for reading files that contain x-y data from powder
 diffraction, spectroscopy and other experimental methods.
 .
 This package contains a small program xyconv that converts files supported
 by the xylib library to TSV (tab-separated values).

## xylib 0.8

=== debian/changelog ===
xylib (0.8-1) unstable; urgency=low

  * New upstream release
  * Upgrade to Standards-Version 3.9.1 (no changes)
  * Add co-Maintainer Carlo Segre <segre@debian.org>

 -- Carlo Segre <segre@debian.org>  Thu, 24 Mar 2011 09:59:46 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: xylib
 Priority: optional
 Maintainer: Marcin Wojdyr <wojdyr@gmail.com>
+Uploaders: Carlo Segre <segre@debian.org>
 Build-Depends: debhelper (>= 7), zlib1g-dev, libbz2-dev, libboost-dev
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Section: science
 Homepage: http://xylib.sourceforge.net/

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

config.status: configure
	dh_testdir
	./configure --disable-static $(CROSS) \
	    --prefix=/usr \
	    --mandir=\$${prefix}/share/man \
	    CFLAGS="$(CFLAGS)" \
	    CXXFLAGS="$(CXXFLAGS)" \
	    LDFLAGS="-Wl,-z,defs" 


build: build-stamp
build-stamp:  config.status
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install


binary-indep: install
# We have nothing to do by default.

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_install --list-missing
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://sf.net/xylib/xylib-(.*)\.tar\.bz2

## xylib 1.3

=== debian/changelog ===
xylib (1.3-1) unstable; urgency=low

  * New upstream release. Closes: #727525.
  * Removed patches not needed for this version.
  * Update URL in the watch file.
  * Use debhelper v9 and minimize the rules file.
  * Do not package libtool .la file.
  * Add multiarch support.
  * Changed Conflict (with old fityk) to Breaks, as lintian suggested.
  * Bumped Standards-Version to 3.9.5.
  * Update year in the copyrights file.

 -- Marcin Wojdyr <wojdyr@gmail.com>  Mon, 3 Feb 2014 23:17:47 +0000

xylib (0.8-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Change Spirit #includes to a new scheme, cherry-pick two upstream commits.
    Closes: #724125

 -- David Prévot <taffit@debian.org>  Thu, 26 Dec 2013 15:18:39 -0400

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,18 @@
 Priority: optional
 Maintainer: Marcin Wojdyr <wojdyr@gmail.com>
 Uploaders: Carlo Segre <segre@debian.org>
-Build-Depends: debhelper (>= 7), zlib1g-dev, libbz2-dev, libboost-dev
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, libbz2-dev, libboost-dev
+Standards-Version: 3.9.5
 Section: science
 Homepage: http://xylib.sourceforge.net/
 
 Package: libxy3
 Section: libs
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: fityk (<< 0.9.2)
+Breaks: fityk (<< 0.9.2)
 Suggests: fityk (>= 0.9.2)
 Description: Library for reading x-y data from several file formats
  C++ library for reading files that contain x-y data from powder diffraction,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autotools_dev --parallel

override_dh_auto_configure:
	dh_auto_configure -- --disable-static

=== debian/watch ===
version=3
https://github.com/wojdyr/xylib/releases/ download/v.*/xylib-(\d.*)\.tar\..+

## xylib 1.6

=== debian/changelog ===
xylib (1.6-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063301

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:08:34 +0000

xylib (1.6-3) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update Standards-Version to 4.6.2 (no changes required).
  * Update debian/watch for github.

 -- Stuart Prescott <stuart@debian.org>  Mon, 02 Oct 2023 12:43:49 +1100

xylib (1.6-2) unstable; urgency=medium

  * Team upload.
  * Transition to wxWidgets 3.2 (Closes: #1019798)

 -- Scott Talbert <swt@techie.net>  Mon, 17 Oct 2022 19:43:24 -0400

xylib (1.6-1) unstable; urgency=medium

  [ Stuart Prescott ]
  * Adopt package into Debian Science Team, with thanks to Marcin Wojdyr and
    Carlo Segre for their previous effort (Closes: #979256).
  * Update watch file format to version 4.
  * Switch build system to cmake.
  * Add WX build-deps to make xyconvert.

  [ Fabian Wolff ]
  * New upstream release, compatible with boost1.74 (Closes: #975672).
  * Upgrade to debhelper compat level 13.
  * Upgrade to Standards-Version 4.5.1.
  * Update Homepage field in debian/control.
  * Rewrite debian/copyright in machine-readable format.
  * Update debian/rules.
  * Add debian/not-installed.
  * Add Vcs-Git and Vcs-Browser fields.
  * Mark libxy-dev as Multi-Arch: same (as suggested by the Multi-Arch
    hinter).

 -- Stuart Prescott <stuart@debian.org>  Fri, 15 Jan 2021 01:00:52 +1100

xylib (1.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename package for GCC 5 transition.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 12 Aug 2015 17:35:50 +0200

=== debian/control ===
Source: xylib
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Stuart Prescott <stuart@debian.org>,
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 libboost-dev,
 libbz2-dev,
 libwxgtk3.2-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Section: science
Homepage: https://github.com/wojdyr/xylib
Vcs-Git: https://salsa.debian.org/science-team/xylib.git
Vcs-Browser: https://salsa.debian.org/science-team/xylib
Rules-Requires-Root: no

Package: libxy3t64
Provides: ${t64:Provides}
X-Time64-Compat: libxy3v5
Replaces: libxy3v5
Breaks: libxy3v5 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fityk,
Description: Library for reading x-y data from several file formats
 C++ library for reading files that contain x-y data from powder diffraction,
 spectroscopy and other experimental methods. The supported formats include:
 VAMAS, pdCIF, Bruker UXD and RAW, Philips UDF and RD, Rigaku DAT,
 Sietronics CPI, DBWS/DMPLOT, Koalariet XDD and others.

Package: libxy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxy3t64 (= ${binary:Version}),
 ${misc:Depends},
Description: xylib development files
 Development files for xylib.
 .
 xylib is a C++ library for reading files that contain x-y data from powder
 diffraction, spectroscopy and other experimental methods.

Package: libxy-bin
Architecture: any
Depends:
 libxy3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: xylib - utilities
 xylib is a C++ library for reading files that contain x-y data from powder
 diffraction, spectroscopy and other experimental methods.
 .
 This package contains a small program xyconv that converts files supported
 by the xylib library to TSV (tab-separated values).

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/wojdyr/xylib/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
